// pserv2View.h : interface of the CPserv2View class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_PSERV2VIEW_H__FA4F3738_2872_4C02_85DA_6C647D5D4415__INCLUDED_)
#define AFX_PSERV2VIEW_H__FA4F3738_2872_4C02_85DA_6C647D5D4415__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "FindDialog.h"
void DisplayErrorMessage(LPCTSTR lpszCaption, ...);

class CPserv2View : public CListView
{
protected: // create from serialization only
	CPserv2View();
	DECLARE_DYNCREATE(CPserv2View)

// Attributes
public:
	CPserv2Doc* GetDocument();
    static BOOL KillProcess(DWORD dwProcessID);

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPserv2View)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void OnInitialUpdate(); // called first time after construct
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnPrint(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CPserv2View();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
    CListViewEntries* m_pEntries;
    CObArray* m_pServices;
    int m_nCurrentIndex;
    CFont m_Font;
    int m_nPointSize;
    CPoint m_LastPoint;
    int m_nPrintServiceIndex;
    DWORD m_dwNumberOfColumns;
    BOOL m_bAnythingHasBeenDisplayed;
    BOOL m_bInsideAutoResize;

    void DisplayAllItems(CListViewEntry* pSelect = NULL);
    CListViewEntry* GetCurrentEntry();
    CService* GetCurrentService()
    {
        return (CService*) GetCurrentEntry();
    }
    int GetSelectedIndices(CUIntArray& listOfIndices);
    int GetFirstSelectedIndex();
    void UpdateCurrentService();
    void OnObjectControl(BEGINSTATFN begin, QUERYSTATEFN query, LPCTSTR lpszAction);
    void OnSetObjectsStartType(SETSTARTTYPEFN lpfn, LPCTSTR lpszAction);

// Generated message map functions
protected:
    CSearchContext m_SearchContext;
	//{{AFX_MSG(CPserv2View)
    afx_msg void OnCustomDraw(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnColumnclick(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnObjectStop();
	afx_msg void OnObjectStart();
    afx_msg void OnObjectRestart();
	afx_msg void OnViewRefresh();
	afx_msg void OnObjectPause();
	afx_msg void OnObjectContinue();
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	afx_msg void OnUpdateObjectStop(CCmdUI* pCmdUI);
	afx_msg void OnUpdateObjectStart(CCmdUI* pCmdUI);
    afx_msg void OnUpdateObjectRestart(CCmdUI* pCmdUI);
	afx_msg void OnUpdateObjectPause(CCmdUI* pCmdUI);
	afx_msg void OnUpdateObjectContinue(CCmdUI* pCmdUI);
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnDoubleClickItem(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnObjectStartOrContinue();
	afx_msg void OnUpdateObjectStartOrContinue(CCmdUI* pCmdUI);
	afx_msg void OnGetInfoTip(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnConnectToLocalMachine();
	afx_msg void OnConnectToRemoteMachine();
	afx_msg void OnOptionsFont();
	afx_msg void OnObjectProperties();
	afx_msg void OnViewFind();
	afx_msg void OnViewFindNext();
	afx_msg void OnObjectEnable();
	afx_msg void OnUpdateObjectEnable(CCmdUI* pCmdUI);
	afx_msg void OnObjectDisable();
	afx_msg void OnUpdateObjectDisable(CCmdUI* pCmdUI);
	afx_msg void OnObjectStartAutomatically();
	afx_msg void OnUpdateObjectStartAutomatically(CCmdUI* pCmdUI);
	afx_msg void OnUpdateObjectProperties(CCmdUI* pCmdUI);
	afx_msg void OnObjectInstall();
	afx_msg void OnObjectDelete();
	afx_msg void OnUpdateObjectDelete(CCmdUI* pCmdUI);
	afx_msg void OnUpdateObjectKillprocess(CCmdUI* pCmdUI);
	afx_msg void OnObjectKillprocess();
	afx_msg void OnHeaderItemChanged(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnUpdateFilePrintPreview(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFilePrint(CCmdUI* pCmdUI);
	afx_msg void OnUpdateObjectInstall(CCmdUI* pCmdUI);
	afx_msg void OnUpdateDisplayExportAsxml(CCmdUI* pCmdUI);
	afx_msg void OnUpdateTemplatesApply(CCmdUI* pCmdUI);
	afx_msg void OnOptionsAutoresizeallcolumns();
	afx_msg void OnViewChoosecolumns();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in pserv2View.cpp
inline CPserv2Doc* CPserv2View::GetDocument()
   { return (CPserv2Doc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PSERV2VIEW_H__FA4F3738_2872_4C02_85DA_6C647D5D4415__INCLUDED_)
